"""
PearProject - `Dragon Curve`
~~~~~~~~~~~~~~~~~~~
Module sur la courbe du dragon.
"""
from .errors import *
from .decorators import *

@type_verifier
def dragon_curve(int_number: int):
    """Calcule la courbe du dragon selon le nombre entier entré.

    Args:
        int_number (int): Nombre entier supérieur ou égale à 1.

    Raises:
        TooSmall: Si le nombre est inférieur ou égal à 1.

    Returns:
        [list]: Retourne une liste avec des nombres entiers supérieur ou égal à 1.
    """
    if int_number <= 1:
        raise TooSmall(0)
    results_list = "0"
    for i in range(2, int_number + 1):
        a = "0"
        b = "0"
        for j in range(len(results_list)):
            a += results_list[j]
            if b == "1":
                a += "0"
                b = "0"
            else:
                a += "1"
                b = "1"
        results_list = a
    return results_list
