"""
PearProject.scripts `phonebook`
~~~~~~~~~~~~~~~~~~~
Script simulant les contacts d'un téléphone (très lite je vais pas vous le cacher).
"""


import time


def spaced_phone_number(arg):
    if len(arg) == 9:
        arg = "0" + arg
    arg = [arg[i : i + 2] for i in range(0, len(arg), 2)]
    return " ".join(arg)


def loading_contacts():
    try :
        contacts = open("contacts.txt", "r")
        contacts = contacts.read()
        contacts = contacts.replace("\n", ";")
        contacts = contacts.replace(" ", "")
        contacts = contacts.replace("ï»¿", "")
        contacts = contacts.split(";")
        phone_number_list = []
        names_list = []
        for element in contacts:
            try:
                element = int(element)
                phone_number_list.append(element)
            except:
                names_list.append(element)
    except FileNotFoundError : 
        phone_number_list, names_list = [],[]
        pass
    return phone_number_list, names_list


def new_contact(phone_number_list, names_list):
    contact_name = str(input("Quel est le nom du contact ? "))
    contact_name = contact_name.replace(" ", "-")
    contact_name = contact_name.replace(";", "")
    contact_name = contact_name.replace("\n", "")
    while True:
        number_phone_contact = str(input(f"Quel est le numéro de {contact_name} ? "))
        try:
            number_phone_contact = number_phone_contact.replace(" ", "")
            if len(number_phone_contact) != 10:
                raise ("")
            number_phone_contact = int(number_phone_contact)
            phone_number_list.append(number_phone_contact)
            names_list.append(contact_name)
            print(
                f'Le numéro "{spaced_phone_number(str(number_phone_contact))}" a bien été attribué à "{contact_name}" !'
            )
            time.sleep(2)
            return phone_number_list, names_list
        except:
            print("Erreur, le numéro doit contenir 10 chiffres uniquement !\n")


def modify_phone_number(phone_number_list, names_list):
    while True:
        contact_name = str(input("Quel contact voulez vous modifier ? "))
        contact_name = contact_name.lower()
        for name in names_list:
            name_lower = name.lower()
            if name_lower == contact_name:
                name_index_list = names_list.index(name)
                while True:
                    number_phone_contact = str(
                        input(
                            f'Son numéro est "{spaced_phone_number(str(phone_number_list[name_index_list]))}", vous voulez le remplacer par quel numéro ?'
                        )
                    )
                    try:
                        number_phone_contact = number_phone_contact.replace(" ", "")
                        number_phone_contact = number_phone_contact.replace(";", "")
                        number_phone_contact = number_phone_contact.replace("\n", "")
                        if len(number_phone_contact) != 10:
                            raise
                        number_phone_contact = int(number_phone_contact)
                        phone_number_list[name_index_list] = number_phone_contact
                        print(
                            f'Le numéro "{spaced_phone_number(str(phone_number_list[name_index_list]))}" a bien été attribué à "{name}" !'
                        )
                        time.sleep(2)
                        return phone_number_list, names_list
                    except:
                        print(
                            "Erreur, le numéro doit contenir 10 chiffres uniquement !\n"
                        )
        print("Le nom de ce contact n'a pas été trouvé dans la liste.")


def delete_contact(phone_number_list, names_list):
    while True:
        contact_name = str(input("Quel contact voulez vous supprimer ? "))
        contact_name = contact_name.lower()
        for name in names_list:
            name_lower = name.lower()
            if name_lower == contact_name:
                name_index_list = names_list.index(name)
                del phone_number_list[name_index_list]
                del names_list[name_index_list]
                print(
                    f'Le numéro "{spaced_phone_number(str(phone_number_list[name_index_list]))}" attribué à "{name}" a bien été supprimé !'
                )
                time.sleep(2)
                return phone_number_list, names_list
        print("Le nom de ce contact n'a pas été trouvé dans la liste.")


def phone_number_search(phone_number_list, names_list):
    while True:
        contact_name = str(input("Vous voulez avoir le numéro de qui ? "))
        contact_name = contact_name.lower()
        for name in names_list:
            name_lower = name.lower()
            if name_lower == contact_name:
                name_index_list = names_list.index(name)
                print(
                    f'Le numéro de "{name} est "{spaced_phone_number(str(phone_number_list[name_index_list]))}" !'
                )
                time.sleep(2)
                return phone_number_list, names_list


def name_search(phone_number_list, names_list):
    while True:
        number_phone_contact = str(
            input("Quel est le numéro que vous voulez rechercher ? ")
        )
        number_phone_contact = number_phone_contact.replace(" ", "")
        number_phone_contact = number_phone_contact.replace(";", "")
        number_phone_contact = number_phone_contact.replace("\n", "")
        try:
            number_phone_contact = int(number_phone_contact)
            for number_phone in phone_number_list:
                if number_phone_contact == number_phone:
                    number_phone_index_list = phone_number_list.index(number_phone)-1
                    print(
                        f'Le numéro "{spaced_phone_number(str(number_phone_contact))}" appartient à "{str(names_list[number_phone_index_list])}" !'
                    )
                    time.sleep(2)
                    return phone_number_list, names_list
        except:
            print("Ce numéro de téléphone n'a pas été trouvé dans la liste.")


def save_contact(phone_number_list, names_list):
    contacts = ""
    for contact_name in names_list:
        name_index_list = names_list.index(contact_name)
        contacts = (
            f'{contacts}{contact_name}; {phone_number_list[name_index_list]}\n'
        )
    fichier = open("contacts.txt", "w")
    fichier.write(contacts)
    print("Les contacts ont bien été sauvegardé !")
    time.sleep(2)
    return


def phonebook():
    phone_number_list, names_list = loading_contacts()
    print("\n\n\nChargement des contacts...")
    time.sleep(2)
    action = 0
    while True:
        while action >= 7 and action <= 1 or action == 0:
            print(
                "\nQue voulez vous faire ?\n 1 – Nouveau contact\n 2 – Modifier un contact\n 3 – Supprimer un contact\n 4 – Rechercher un numéro\n 5 – Rechercher un nom\n 6 – Sauvegarder le répertoire\n 7 – Quitter",
                end="\n",
            )
            action = int(input())
        if action == 1:
            print("Nouveau contact :")
            phone_number_list, names_list = new_contact(phone_number_list, names_list)
        elif action == 2:
            print("Modifier un contact :")
            phone_number_list, names_list = modify_phone_number(
                phone_number_list, names_list
            )
        elif action == 3:
            print("Supprimer un contact :")
            phone_number_list, names_list = delete_contact(
                phone_number_list, names_list
            )
        elif action == 4:
            print("Rechercher un numéro :")
            phone_number_list, names_list = phone_number_search(
                phone_number_list, names_list
            )
        elif action == 5:
            print("Rechercher un nom")
            phone_number_list, names_list = name_search(phone_number_list, names_list)
        elif action == 6:
            print("Sauvegarder le répertoire")
            save_contact(phone_number_list, names_list)
        elif action == 7:
            print("Au revoir !")
            exit()
        action = 0

if __name__ == "__main__" :
    phonebook()